local Loveable=require 'Loveable'
local Mountains=require 'Mountains'
local Lander=require 'Lander'
local Sounds=require 'Sounds'
local Welcome=require 'Welcome'()

local M=class(Loveable, function(self, W, H)
  Loveable.init(self)
  self.Mountains=Mountains(self):setSize(W, H)
  self.Lander=Lander(self):setSize(W, H)
  self.Sounds=Sounds(self)
  self:add(self.Mountains)
  self:add(self.Lander)
  self:add(self.Sounds)
  self.start=true
end)

function M:changeOffset(dx)
  for k,v in pairs(self.Children) do
    if v.changeOffset then
      v:changeOffset(dx)
    end
  end
end

function M:setPause(m)
  self.paused=m
  self.Lander.paused=self.paused
end


function M:keypressed(a, b)
  if self.start then
    self.start=nil
    return
  end
  if a=='p' then
    self:setPause(not self.paused)
  else
    Loveable.keypressed(self, a, b)
  end
end

function M:update()
  if self.start then
    return
  end
  Loveable.update(self)
end

function M:draw()
  if self.start then
    Welcome:draw()
  else
    Loveable.draw(self)
    if self.paused then
      love.graphics.print('PAUSED', 200,100)
    end
  end
end

function M:load()
  love.mouse.setVisible(false)
  SMALLFONT=love.graphics.newFont('trebuc.ttf', 14)
  BIGFONT=love.graphics.newFont('trebuc.ttf', 36)
  love.graphics.setFont(SMALLFONT)
end

return M

