require 'class'

local M=class(function(self)
  self.Children={}
end)

function M:add(element)
  table.insert(self.Children, element)
end

function M:remove(element)
  for k,v in ipairs(self.Children) do
    if v==element then
      table.remove(self.Children, k)
      return true
    end
  end
end

function M:load()
  for k,v in ipairs(self.Children) do
    v:load()
  end
end

function M:draw()
  for k,v in ipairs(self.Children) do
    v:draw()
  end
end

function M:update(dt)
  for k,v in ipairs(self.Children) do
    v:update(dt)
  end
end

function M:mousepressed(x, y, b)
  for k,v in ipairs(self.Children) do
    v:mousepressed(x, y, b)
  end
end

function M:mousereleased(x, y, b)
  for k,v in ipairs(self.Children) do
    v:mousereleased(x, y, b)
  end
end

function M:keypressed(a, b)
  for k,v in ipairs(self.Children) do
    v:keypressed(a, b)
  end
end

return M

